package cc.smtweb.system.bpm.web.engine.model.listcard.lclc1;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageService;
import cc.smtweb.system.bpm.web.engine.model.listcard.abshandler.ModelDelHandler;
import cc.smtweb.system.bpm.web.engine.model.listcard.abshandler.ModelLoadHandler;
import cc.smtweb.system.bpm.web.engine.model.listcard.abshandler.ModelSaveHandler;
import cc.smtweb.system.bpm.web.engine.model.listcard.abshandler.ModelService;

/**
 * @Author:lip
 * @Date : 2022/9/2 11:34
 */
@SwService
public class LCLC1Service extends ModelService {
    @Override
    protected ModelSaveHandler getSaveHandler() {
        return new LCLC1SaveHandler();
    }

    @Override
    protected ModelLoadHandler getLoadHandler() {
        return new LCLC1LoadHandler();
    }

    @Override
    protected ModelDelHandler getDelHandler() {
        return new LCLC1DelHandler();
    }

    //保存
    public R modelLSave(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_SAVE, handler -> ((LCLC1SaveHandler) handler).lSave());
    }

    //读取
    public R modelLLoad(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LOAD, handler -> ((LCLC1LoadHandler) handler).lLoad());
    }

    //读取
    public R modelLAdd(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_ADD, handler -> ((LCLC1LoadHandler) handler).lAdd());
    }

    //删除
    public R modelLLDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCLC1DelHandler) handler).lDel());
    }

    //删除
    public R modelLCDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCLC1DelHandler) handler).lDel());
    }

    //列表数据
    public R modelLList(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCLC1LoadHandler) handler).lList());
    }

    //列表总记录数及合计栏
    public R modelLListTotal(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCLC1LoadHandler) handler).getLTotal());
    }

    //右表
    //保存
    public R modelRSave(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_SAVE, handler -> ((LCLC1SaveHandler) handler).rSave());
    }

    //读取
    public R modelRLoad(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LOAD, handler -> ((LCLC1LoadHandler) handler).rLoad());
    }

    //读取
    public R modelRAdd(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_ADD, handler -> ((LCLC1LoadHandler) handler).rAdd());
    }

    //删除
    public R modelRLDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCLC1DelHandler) handler).rDel());
    }

    //删除
    public R modelRCDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCLC1DelHandler) handler).rDel());
    }

    //列表数据
    public R modelRList(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCLC1LoadHandler) handler).rList());
    }

    //列表总记录数及合计栏
    public R modelRListTotal(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCLC1LoadHandler) handler).getRTotal());
    }

}
