package cc.smtweb.framework.core.systask;

import cc.smtweb.framework.core.cache.redis.RedisManager;
import cc.smtweb.framework.core.exception.SwException;
import cc.smtweb.framework.core.util.DateUtil;
import cc.smtweb.framework.core.util.StringUtil;

public class SingleRequestHelper {

    public static interface ISingleWork {
        void doSingleWork() throws Exception;

    }

    public static void singleRequest(String region_key, String key, ISingleWork singleWork) throws Exception {
        singleRequest(region_key, key, "其他人正在执行该操作，请等待！", singleWork);
    }

    public static void singleRequest(String region_key, String key, String tip_msg, ISingleWork singleWork) throws Exception {
        boolean clearCache = false;
        try {
            String lastTime = RedisManager.getInstance().hGet(region_key, key, String.class);
            if (StringUtil.isNotEmpty(lastTime)) {
                throw new SwException(tip_msg);
            }
            RedisManager.getInstance().hSet(region_key, key, DateUtil.nowDateString());
            clearCache = true;
            singleWork.doSingleWork();
        } finally {
            if (clearCache) RedisManager.getInstance().hdel(region_key, key);
        }
    }
}
