package cc.smtweb.framework.core.systask;


import cc.smtweb.framework.core.util.StringUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public abstract class SysThreadWorker implements Runnable {
    private String loginPartyId;

    private String loginOwnerPartyId;

    private String bizName;

    protected SysThreadWorker(String loginPartyId, String loginOwnerPartyId) {
        this.loginPartyId = loginPartyId;
        this.loginOwnerPartyId = loginOwnerPartyId;
    }

    protected SysThreadWorker(String loginPartyId, String loginOwnerPartyId, String bizName) {
        this.loginPartyId = loginPartyId;
        this.loginOwnerPartyId = loginOwnerPartyId;
        this.bizName = StringUtil.checkNull(bizName);
    }


    @Override
    public void run() {
        try {
//            SysParams.setLoginOwnerPartyId(loginOwnerPartyId);
//            SysParams.setLoginPartyId(loginPartyId);
            localWork();
        } catch (Exception e) {
            log.error("DfpPool handle error：", e);
        }
    }

    public abstract void localWork() throws Exception;
}
